#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySummerPlanRedpacketCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySummerPlanRedpacketCFG> M_ActivitySummerPlanRedpacketCFG::msSingleton(nullptr);

int M_ActivitySummerPlanRedpacketCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanRedpacketCFGData* M_ActivitySummerPlanRedpacketCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySummerPlanRedpacketCFGData>& M_ActivitySummerPlanRedpacketCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanRedpacketCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySummerPlanRedpacketCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanRedpacketCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mNeedType = element->IntAttribute("NeedType");
		data.mNeedCount = element->IntAttribute("NeedCount");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		{
			const char* ItemProbability = element->Attribute("ItemProbability");
			std::vector<std::string> vecItemProbability;
			boost::split(vecItemProbability, ItemProbability, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemProbability.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemProbability[i].c_str(), &temp))
				{
					data.mItemProbability.push_back(temp);
				}
			}
		}
		data.mShowName = element->Attribute("ShowName");
		data.mRewardTitle = element->Attribute("RewardTitle");
		data.mNeedActive = element->IntAttribute("NeedActive");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySummerPlanRedpacketCFG::Load()
{
	Load("../Config/M_ActivitySummerPlanRedpacketCFG.xml");
}

M_ActivitySummerPlanRedpacketCFG* M_ActivitySummerPlanRedpacketCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanRedpacketCFG());
	}
	return msSingleton.get();
}
